

#ifndef _CADEBUG_
#define _CADEBUG_

#define TRACING			0
#define TRACELEVEL		3
#define RUNTIME_DEBUG	0

//-------------------------------------------------------------------------
// Forward Declarations
//-------------------------------------------------------------------------

class TCATracer;

//-------------------------------------------------------------------------
// Externed Global Declarations
//-------------------------------------------------------------------------

extern TCATracer*	gCATracer;

//-------------------------------------------------------------------------
// Debugging
//-------------------------------------------------------------------------

void		CADebugStr (char* routineName, char* message);
Boolean		IsValidCADocumentRef (CADocumentRef document);


#define VALIDATE_OBJECT(r,o)	if (!ODIsBlockAnObject ((void*)o))	\
									CADebugStr (r, "Invalid object");
									
#define VALIDATE_DOCREF(r,d)	if (!IsValidCADocumentRef (d))	\
									CADebugStr (r, "Invalid CADocumentRef");
									
#define VALIDATE_FRAMEREF(r,d,f)	if (!FrameRefValid (d,f))	\
									CADebugStr (r, "Invalid CAFrameRef");

//-------------------------------------------------------------------------
// class Tracer
//-------------------------------------------------------------------------

class TCATracer
{
	
	public:
	
		TCATracer(FSSpec* spec, Boolean flushLog);
		~TCATracer();
		
		//void		PrintEntry (char* routine, char* message);
		//void		PrintEntry (char* routine, char* message, long num);
		void		Log (char* message);

	private:
	
		short	fLogRefNum;
		FSSpec	fLogSpec;

};

void _Trace(short traceLevel, char *fmt, ... );

#define TRACE	if(!TRACING) ; else _Trace

#endif