/*
	File:			CADisptch.h

	Contains:		CADispatcher interface

	Written by:	Rick Badertscher

	Copyright:	 1993-95 by Apple Computer, Inc., all rights reserved.

	Change History (most recent first):

		 <1>	  11/10/95	RB		Added CADispatcher::DispatchUpdateEvent()
		 <0>	  8/2/95	RB		Created


	To Do:
*/

#ifndef _CADISPTCH_
#define _CADISPTCH_


//==============================================================================
// Theory of Operation
//==============================================================================

//==============================================================================
// Constants
//==============================================================================

//-------------------------------------------------------------------------------------
// Menus
//-------------------------------------------------------------------------------------


//==============================================================================
// Classes defined in this interface
//==============================================================================

class CADispatcher;

//==============================================================================
// Classes (potentially) used by this interface
//==============================================================================

class ODSession;
class ODWindowState;
class ODMenuBar;

//==============================================================================
// Functions defined in this interface
//==============================================================================


//==============================================================================
// CADispatcher
//==============================================================================


class CADispatcher
{

	public:

								CADispatcher();
								~CADispatcher();

		void					Initialize(					ODSession* session);
		Boolean					DispatchEvent(				EventRecord* event, CAEventInfo* eventInfo);
		Boolean					DispatchMenuEvent(			ODEventData* event);
	
	private:
	
		// Event dispatch methods
		Boolean					DispatchUpdateEvent(		ODEventData* event);
		Boolean					DispatchMouseEvent(			ODEventData* event, CAEventInfo* eventInfo);
		Boolean					DispatchOSEvent(			ODEventData* event, CAEventInfo* eventInfo);

		// Event handling methods
		void					HandleMouseDownInWindow(	WindowPtr window, ODSShort partCode, ODEventData* event);
		void					HandleMouseDownInCloseBox(	WindowPtr window, ODEventData* event);
		void					HandleMouseDownInDragRegion(WindowPtr window, ODEventData* event);
		void					HandleMouseDownInGrowBox(	WindowPtr window, ODEventData* event);
		void					HandleMouseDownInZoomBox(	WindowPtr window, ODSShort partcode, ODEventData* event);


//-------------------------------------------------------------------------------------
// private fields
//-------------------------------------------------------------------------------------
	
		Environment*			fEV;
		ODDispatcher* 			fDispatcher;
		ODWindowState*			fWindowState;

};

#endif
