/*
	File:		CAError.h

	Contains:	CAError definitions

	Written by:	Rick Badertscher

	Copyright:	 1994 by Apple Computer, Inc., all rights reserved.

	Change History (most recent first):


		 <0>	8/17/95	RB		Created
	To Do:
		- Compile
		- Implement
*/


#ifndef _CAERROR_
#define _CAERROR_

#ifndef _EXCEPT_
#include <Except.h>
#endif

//-------------------------------------------------------------------------
// Error reporting
//-------------------------------------------------------------------------


void	ClearCAError( );			// all at start of each CA function!

void	SetCAError( OSErr );		// Warning: This function might not return


/*	CA_CATCH is a macro for use in CA function implementations. It will catch
			 any exception thrown during that function's execution, set
			 CAError, and run the block follwing CA_CATCH. This block _must_
			 return from the function. An example:
			 
			 	Boolean CAFoo( ) {
			 		CA_CATCH
			 			return false;
			 		
			 		ODDoSomethingThatMightThrow();
			 		return true;
			 	}
*/


#ifndef _NATIVE_EXCEPTIONS_

// inherit to change the SOM name for the class
struct TCAException :public ODExceptionFrame
{

};

#define CA_TRY 												\
		{													\
			gCAError = noErr;								\
			TCAException _except;							\
			ODVolatile(_except);							\
			if (_setjmp_xTry(&_except) == 0)				\
			{

#define CA_CATCH_ALL										\
			CATCH_ALL										\
			SetCAError (_except.fError);
				
#define CA_ENDTRY											\
			ENDTRY

// DHN 10/30/94 changed from Volatile to ODVolatile
#define CA_CATCH											\
		TCAException _except;								\
		ODVolatile(_except);								\
		if( setjmp((*_xTry(&_except))) != 0 )					\
			for( ; true; _except.SpazDidntReturn() )

#else

#define CA_TRY 													\
			TRY
			
#define CA_CATCH_ALL											\
			CATCH_ALL											\
				SetCAError((OSErr) _exception.error);
				
#define CA_ENDTRY												\
			ENDTRY

#define CA_CATCH												\
		if (0)

#endif


#endif /*_CAERROR_*/
