/*
	File:			CAFileUtils.h

	Contains:		File utilities

	Written by:	Rick Badertscher

	Copyright:	 1993-95 by Apple Computer, Inc., all rights reserved.

	Change History (most recent first):

		 <0>	  7/20/95	RB		Created


	To Do:
*/

#ifndef _CAFILEUTILS_
#define _CAFILEUTILS_

#ifndef _PLFMFILE_
#include <PlfmFile.h>
#endif


//==============================================================================
// Classes (potentially) used by this interface
//==============================================================================

class ODDocument;
class ODContainer;
class PlatformFile;

void			CreateUntitledContainer(	Environment* ev,
											ODSession*	session,
											ODDocument** documentPtr,
											ODContainer** containerPtr,
											PlatformFile* newFile,
											ODName* fileNameSeed);

PlatformFile*	CreateTempContainer(		Environment* ev,
											ODSession*	session,
											ODDocument** documentPtr,
											ODContainer** containerPtr);

PlatformFile*	CreateTempFile(				ODOSType creator,
											ODOSType fileType,
											ODName* fileNameSeed);

PlatformFile*	CreatePartFromStationary (PlatformFile* file, ODPart** part);


#endif