/*
	File:		CAFrmUtils.h

	Contains:	Contains frame utilities implementation

	Written by:	Rick Badertscher

	Copyright:	 1994 by Apple Computer, Inc., all rights reserved.

	Change History (most recent first):


		 <0>	8/17/95	RB		Created
	To Do:
		- Compile
		- Implement
*/

#ifndef _CAFRMUTL_
#define _CAFRMUTL_

//-------------------------------------------------------------------------


#define kRootFrameRef	1

//-------------------------------------------------------------------------
// FrameRef utility routines

ODID				GetIDFromFrameRef(CADocumentRef document, CAFrameRef frameRef);
CAFrameRef			GetFrameRefFromID(CADocumentRef document, ODID frameID);

ODFrame*			AcquireFrameFromFrameRef(	CADocumentRef	document,
												CAFrameRef		frameRef);
									
CAFrameRef			FrameRefFromFrame(	CADocumentRef	document,
										ODFrame*		frame);

ODFacet*			FacetFromFrameRef(	CADocumentRef	document,
										CAFrameRef		frame);

ODFrame*			GetRootFrame(		CADocumentRef	document );
CAFrameRef			GetRootFrameRef(	CADocumentRef	document );
Boolean				FrameRefValid(		CADocumentRef document, CAFrameRef frameRef);

																			
#endif /* _CAFRMUTL_ */
