/*
	File:		CAUtil.h

	Contains:	CALib Utility definitions

	Written by:	Rick Badertscher

	Copyright:	 1994 by Apple Computer, Inc., all rights reserved.

	Change History (most recent first):


		 <0>	8/17/95	RB		Created
	To Do:
		- Compile
		- Implement
*/

#ifndef _CAUTIL_
#define _CAUTIL_

class ODFrame;
class ODEventInfo;


//=========================================================================
// CALib utility routines
//=========================================================================
 
// ProxyPart notification

void				CallProxyAddFrame( 	CADocumentRef	document,
										ODFrame*		frame);

void				GetEventInfo(		CADocumentRef document, ODEventInfo* eventInfo);

Boolean				IsCAProxyPartDraft( ODDraft*);
Boolean				IsCAProxyPart(		ODPart*);

Boolean				FailIfNotVisible (	CADocumentRef	doc);

// Prototypes for ProxyHook routines

pascal void ProxyHook_FrameShapeRequest (CAFrameShapeRequestHandler handler,
										ODDraft*			document,
										ODFrame*			frame,
										ODShape*			shape);

pascal void ProxyHook_AdjustBorder (	CAAdjustBorderProc adjustBorderProc,
										ODDraft* document,
										ODFrame* frame,
										ODShape* shape);
#endif /*_CAUTIL_*/
